<?xml version="1.0"?>
<launch>

    <!-- <arg name="hardware_interface" default="EffortJointInterface"/> -->
    <arg name="hardware_interface" default="PositionJointInterface"/>
    <arg name="arm_id" default="panda" />
    <arg name="debug" default="true"/>
    
    <!-- loads the Gazebo world. -->
    <include file="$(find gazebo_ros)/launch/empty_world.launch">
        <arg name="world_name" value="$(find gazebo_environment)/worlds/default.world"/>
        <arg name="debug" value="$(arg debug)" />
        <arg name="gui" value="true" />
        <arg name="paused" value="true"/>
        <arg name="use_sim_time" value="true"/>
        <arg name="headless" value="false"/>
    </include>
    
    <!-- load the URDF with the given hardware interface and robot name into the ROS Parameter Server -->
    <!-- Note the syntax to pass a vector -->
    <!-- <arg name="origin_xyz" default="'0 0 0'"/> 
    <arg name="origin_rpy" default="'0 0 0'"/> -->
    
    <param name="robot_description" command="$(find xacro)/xacro --inorder '$(find franka_description)/robots/panda_hand.urdf.xacro' hardware_interface:=$(arg hardware_interface) arm_id:=$(arg arm_id)"/>
    
    <!-- spawn the URDF robot -->
    <node name="spawn" pkg="gazebo_ros" type="spawn_model" respawn="false" output="screen" 
          args="-param robot_description -urdf -model $(arg arm_id)"/>

    <!-- spawn controllers -->
    <group ns="$(arg arm_id)">
        <include file="$(find gazebo_controllers)/launch/panda_hand_controller_position_interface.launch">
            <arg name="hardware_interface" value="$(arg hardware_interface)" />
            <arg name="arm_id" value="$(arg arm_id)" />
        </include>
    </group>

</launch>
